unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ComCtrls, ExtCtrls, StdCtrls, XPMan;

type
  TForm1 = class(TForm)
    Memo: TRichEdit;
    Panel: TPanel;
    Edit1: TEdit;
    SaveDialog: TSaveDialog;
    XPManifest1: TXPManifest;
    procedure FormCreate(Sender: TObject);
    procedure Edit1KeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
type
  TFunc = function (s:TStringList;str:string):integer;

var
  Form1: TForm1;
  HLibrary: Thandle;
  i:TColor;
implementation

{$R *.dfm}
//=====================
function GetToken(aString, SepChar: String; TokenNum: Byte):String;
{
: aString :  

SepChar :  , 
   ()
TokenNum:    ())
result    :     ,   

  'TokenNum'
}
var

Token     : String;
StrLen    : Byte;
TNum      : Byte;
TEnd      : Byte;
begin

StrLen := Length(aString);
TNum   := 1;
TEnd   := StrLen;
while ((TNum <= TokenNum) and (TEnd <> 0)) do
begin
TEnd := Pos(SepChar,aString);
if TEnd <> 0 then
begin
Token := Copy(aString,1,TEnd-1);
Delete(aString,1,TEnd);
Inc(TNum);
end
else
begin
Token := aString;
end;
end;
if TNum >= TokenNum then
begin
GetToken := Token;
end
else
begin
GetToken := '';
end;
end;
//=====================
procedure TForm1.FormCreate(Sender: TObject);
begin
Edit1.Align:=alClient;
memo.Lines.LoadFromFile('..\Bin\StartPage.rtf');
HLibrary := LoadLibrary('..\dll\Project1.dll');
if HLibrary >= 32 then {  }
begin
//Func := GetProcAddress(HLibrary, 'h');
//Func(TStringList(memo1.Lines));
end
else
MessageDlg(':    DLL', mtError, [mbOk], 0);

memo.SelLength:=0;
end;

procedure TForm1.Edit1KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
var
  Func:TFunc;
  GetCommandPromt : Function:string;
  s:string;
  b:TRichEdit;
  CommandPromt_:string;
begin

if Edit1.Text = 'cls' then memo.Clear;
memo.Font.Color :=clBlack;
if Edit1.Text = 'save' then
  if SaveDialog.Execute then
    if SaveDialog.FileName<>'' then memo.Lines.SaveToFile(SaveDialog.FileName);
    
if key=Vk_Return then begin
SendMessage(Memo.Handle, EM_SCROLLCARET, 0, 0);

memo.SelAttributes.Color:=clWhite;
try
GetCommandPromt:= GetProcAddress(HLibrary, 'GetCommandPromt');
CommandPromt_:=GetCommandPromt;
except end;
memo.Lines.Add(CommandPromt_+Edit1.Text);

Func := GetProcAddress(HLibrary, PChar(GetToken(Edit1.Text,' ',1)));
s:=GetToken(Edit1.Text,'"',2);

b:=TRichEdit.Create(Form1);
b.ParentWindow:=Form1.Handle;
try
i:= Func(TStringList(b.Lines) ,s);
except end;
memo.SelAttributes.Color:=TColor(i);
memo.Lines.AddStrings(b.Lines);
memo.SelLength:=0;
b.Free;
Edit1.Clear;
end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
FreeLibrary(HLibrary);
end;


procedure TForm1.FormShow(Sender: TObject);
begin
Edit1.SetFocus;
end;

end.
